#ifndef _BIP_Engine_InteractionItf_HPP_
#define _BIP_Engine_InteractionItf_HPP_

#include <bip-engineiface-config.hpp>
using namespace bipbasetypes;
using namespace biptypes;

// referenced classes
class Connector;
class Port;

class Component;

class InteractionItf {
 public:
  // destructor
  virtual ~InteractionItf();

  // getters for references
  virtual const vector<Port *> &ports() const = 0;
  virtual bool hasPorts() const = 0;
  const Connector &connector() const { return mConnector; }

 protected:
  // protected constructors
  InteractionItf(const Connector &connector);

  // protected getters for references
  virtual vector<Port *> &ports() = 0;

  // references
  const Connector &mConnector;
};

#endif // _BIP_Engine_InteractionItf_HPP_
